diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/he/he-ru.cc ns-3.45/src/wifi/model/he/he-ru.cc
--- ns-3.44/src/wifi/model/he/he-ru.cc	2025-03-09 16:55:49.791372500 -0700
+++ ns-3.45/src/wifi/model/he/he-ru.cc	2025-06-01 20:34:45.617702200 -0700
@@ -853,8 +774,8 @@
             nCentral26TonesRus = 5;
         }
         break;
-    case RU_242_TONE:
-    case RU_484_TONE:
+    case RuType::RU_242_TONE:
+    case RuType::RU_484_TONE:
         nCentral26TonesRus = (bandwidth >= MHz_u{80} ? 1 : 0);
         break;
     default:
@@ -866,7 +787,7 @@
         nCentral26TonesRus *= 2;
     }
 
-    return ruType;
+    return nCentral26TonesRus;
 }
 
 bool
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/he/he-ru.h ns-3.45/src/wifi/model/he/he-ru.h
--- ns-3.44/src/wifi/model/he/he-ru.h	2025-03-09 16:55:49.791372500 -0700
+++ ns-3.45/src/wifi/model/he/he-ru.h	2025-06-01 20:34:45.617702200 -0700
@@ -26,26 +26,6 @@
 {
   public:
     /**
-     * The different HE Resource Unit (RU) types.
-     */
-    enum RuType
-    {
-        RU_26_TONE = 0,
-        RU_52_TONE,
-        RU_106_TONE,
-        RU_242_TONE,
-        RU_484_TONE,
-        RU_996_TONE,
-        RU_2x996_TONE
-    };
-
-    /// (lowest index, highest index) pair defining a subcarrier range
-    typedef std::pair<int16_t, int16_t> SubcarrierRange;
-
-    /// a vector of subcarrier ranges defining a subcarrier group
-    typedef std::vector<SubcarrierRange> SubcarrierGroup;
-
-    /**
      * RU Specification. Stores the information carried by the RU Allocation subfield
      * of the User Info field of Trigger frames (see 9.3.1.22.1 of 802.11ax D8.0).
      * Note that primary80MHz must be true if ruType is RU_2x996_TONE.
@@ -59,7 +39,7 @@
         /**
          * Default constructor
          */
-        RuSpec();
+        RuSpec() = default;
         /**
          * Constructor
          *
@@ -119,39 +99,36 @@
         bool operator<(const RuSpec& other) const;
 
       private:
-        RuType m_ruType;     //!< RU type
-        std::size_t m_index; /**< RU index (starting at 1) as defined by Tables 27-7
+        RuType m_ruType{};     //!< RU type
+        std::size_t m_index{}; /**< RU index (starting at 1) as defined by Tables 27-7
                                   to 27-9 of 802.11ax D8.0 */
-        bool m_primary80MHz; //!< true if the RU is allocated in the primary 80MHz channel
+        bool m_primary80MHz{}; //!< true if the RU is allocated in the primary 80MHz channel
     };
 
     /**
-     * Struct providing a function call operator to compare two RUs.
+     * Get the primary 80 MHz flag of a given RU transmitted in a PPDU.
+     * The flag identifies whether the RU is in the primary 80 MHz.
+     *
+     * @param bw the bandwidth of the PPDU (20, 40, 80, 160)
+     * @param ruType the RU type (number of tones)
+     * @param phyIndex the PHY index (starting at 1) of the RU
+     * @param p20Index the index of the primary20 channel
+     * @return the primary 80 MHz flag
      */
-    struct RuSpecCompare
-    {
-        /**
-         * Constructor.
-         *
-         * @param channelWidth the channel width
-         * @param p20Index the index of the primary20 channel
-         */
-        RuSpecCompare(MHz_u channelWidth, uint8_t p20Index);
-        /**
-         * Function call operator.
-         *
-         * @param lhs left hand side RU
-         * @param rhs right hand side RU
-         * @return true if the left hand side RU has its leftmost tone at a lower
-         *         frequency than the leftmost tone of the right hand side RU,
-         *         false otherwise
-         */
-        bool operator()(const RuSpec& lhs, const RuSpec& rhs) const;
+    static bool GetPrimary80MHzFlag(MHz_u bw,
+                                    RuType ruType,
+                                    std::size_t phyIndex,
+                                    uint8_t p20Index);
 
-      private:
-        MHz_u m_channelWidth; ///< The channel width
-        uint8_t m_p20Index;   ///< Primary20 channel index
-    };
+    /**
+     * Get the index of a given RU transmitted in a PPDU within its 80 MHz segment.
+     *
+     * @param bw the bandwidth of the PPDU (20, 40, 80, 160)
+     * @param ruType the RU type (number of tones)
+     * @param phyIndex the PHY index (starting at 1) of the RU
+     * @return the index within the 80 MHz segment
+     */
+    static std::size_t GetIndexIn80MHzSegment(MHz_u bw, RuType ruType, std::size_t phyIndex);
 
     /**
      * Get the number of distinct RUs of the given type (number of tones)
@@ -171,7 +148,7 @@
      * @param ruType the RU type (number of tones)
      * @return the set of distinct RUs available
      */
-    static std::vector<HeRu::RuSpec> GetRusOfType(MHz_u bw, HeRu::RuType ruType);
+    static std::vector<RuSpec> GetRusOfType(MHz_u bw, RuType ruType);
 
     /**
      * Get the set of 26-tone RUs that can be additionally allocated if the given
@@ -181,7 +158,7 @@
      * @param ruType the RU type (number of tones)
      * @return the set of 26-tone RUs that can be additionally allocated
      */
-    static std::vector<HeRu::RuSpec> GetCentral26TonesRus(MHz_u bw, HeRu::RuType ruType);
+    static std::vector<RuSpec> GetCentral26TonesRus(MHz_u bw, RuType ruType);
 
     /**
      * Get the subcarrier group of the RU having the given PHY index among all the
@@ -212,22 +189,6 @@
     static bool DoesOverlap(MHz_u bw, RuSpec ru, const std::vector<RuSpec>& v);
 
     /**
-     * Check whether the given RU overlaps with the given tone ranges.
-     * Note that for channel width of 160 MHz the returned range is relative to
-     * the 160 MHz channel (i.e. -1012 to 1012).
-     *
-     * @param bw the bandwidth of the HE PPDU (20, 40, 80, 160)
-     * @param ru the given RU allocation
-     * @param toneRanges the given set of tone ranges
-     * @param p20Index the index of the primary20 channel
-     * @return true if the given RU overlaps with the given set of tone ranges.
-     */
-    static bool DoesOverlap(MHz_u bw,
-                            RuSpec ru,
-                            const SubcarrierGroup& toneRanges,
-                            uint8_t p20Index);
-
-    /**
      * Find the RU allocation of the given RU type overlapping the given
      * reference RU allocation.
      * Note that an assert is generated if the RU allocation is not found.
@@ -240,22 +201,6 @@
     static RuSpec FindOverlappingRu(MHz_u bw, RuSpec referenceRu, RuType searchedRuType);
 
     /**
-     * Get the approximate bandwidth occupied by a RU.
-     *
-     * @param ruType the RU type
-     * @return the approximate bandwidth occupied by the RU
-     */
-    static MHz_u GetBandwidth(RuType ruType);
-
-    /**
-     * Get the RU corresponding to the approximate bandwidth.
-     *
-     * @param bandwidth the approximate bandwidth occupied by the RU
-     * @return the RU type
-     */
-    static RuType GetRuType(MHz_u bandwidth);
-
-    /**
      * Given the channel bandwidth and the number of stations candidate for being
      * assigned an RU, maximize the number of candidate stations that can be assigned
      * an RU subject to the constraint that all the stations must be assigned an RU
@@ -272,12 +217,6 @@
                                               std::size_t& nStations,
                                               std::size_t& nCentral26TonesRus);
 
-    /// (bandwidth, number of tones) pair
-    typedef std::pair<MHz_u, RuType> BwTonesPair;
-
-    /// map (bandwidth, number of tones) pairs to the group of subcarrier ranges
-    typedef std::map<BwTonesPair, std::vector<SubcarrierGroup>> SubcarrierGroups;
-
     /// Subcarrier groups for all RUs (with indices being applicable to primary 80 MHz channel)
     static const SubcarrierGroups m_heRuSubcarrierGroups;
 
@@ -288,31 +227,32 @@
     static const RuAllocationMap m_heRuAllocations;
 
     /// Get the RU specs based on RU_ALLOCATION
-    /// @param ruAllocation 8 bit RU_ALLOCATION value
+    /// @param ruAllocation 9 bit RU_ALLOCATION value
     /// @return RU spec associated with the RU_ALLOCATION
-    static std::vector<RuSpec> GetRuSpecs(uint8_t ruAllocation);
+    static std::vector<RuSpec> GetRuSpecs(uint16_t ruAllocation);
 
     /// Get the RU_ALLOCATION value for equal size RUs
     /// @param ruType equal size RU type (generated by GetEqualSizedRusForStations)
     /// @param isOdd if number of stations is an odd number
+    /// @param hasUsers whether it contributes to User field(s) in the content channel this RU
+    /// Allocation belongs to
     /// @return RU_ALLOCATION value
-    static uint8_t GetEqualizedRuAllocation(RuType ruType, bool isOdd);
+    static uint16_t GetEqualizedRuAllocation(RuType ruType, bool isOdd, bool hasUsers);
 
-    /// Empty 242-tone RU identifier
-    static constexpr uint8_t EMPTY_242_TONE_RU = 113;
+  private:
+    /**
+     * Get the number of 26-tone RUs that can be allocated if returned RU size is greater than 26
+     * tones.
+     *
+     * @param bw the bandwidth (MHz) of the HE PPDU (20, 40, 80, 160)
+     * @param ruType the RU type (number of tones)
+     * @return the number of 26-tone RUs that can be allocated
+     */
+    static uint8_t GetNumCentral26TonesRus(MHz_u bw, RuType ruType);
 };
 
 /**
  * @brief Stream insertion operator.
- *
- * @param os the stream
- * @param ruType the RU type
- * @returns a reference to the stream
- */
-std::ostream& operator<<(std::ostream& os, const HeRu::RuType& ruType);
-
-/**
- * @brief Stream insertion operator.
  *
  * @param os the stream
  * @param ru the RU
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/he/mu-edca-parameter-set.cc ns-3.45/src/wifi/model/he/mu-edca-parameter-set.cc
--- ns-3.44/src/wifi/model/he/mu-edca-parameter-set.cc	2025-03-09 16:55:49.791372500 -0700
+++ ns-3.45/src/wifi/model/he/mu-edca-parameter-set.cc	2025-06-01 20:34:45.617702200 -0700
@@ -155,4 +155,16 @@
     return 13;
 }
 
+void
+MuEdcaParameterSet::Print(std::ostream& os) const
+{
+    os << "MU EDCA Parameter Set=[QoS Info: " << +m_qosInfo << ", MU Parameter Records=";
+    for (const auto& record : m_records)
+    {
+        os << "{AIFSN: " << +record.aifsnField << ", CWmin/max: " << +record.cwMinMax
+           << ", MU EDCA Timer: " << +record.muEdcaTimer << "}, ";
+    }
+    os << "]";
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/he/mu-edca-parameter-set.h ns-3.45/src/wifi/model/he/mu-edca-parameter-set.h
--- ns-3.44/src/wifi/model/he/mu-edca-parameter-set.h	2025-03-09 16:55:49.791372500 -0700
+++ ns-3.45/src/wifi/model/he/mu-edca-parameter-set.h	2025-06-01 20:34:45.618702200 -0700
@@ -120,6 +120,7 @@
     uint16_t GetInformationFieldSize() const override;
     void SerializeInformationField(Buffer::Iterator start) const override;
     uint16_t DeserializeInformationField(Buffer::Iterator start, uint16_t length) override;
+    void Print(std::ostream& os) const override;
 
     /**
      * MU AC Parameter Record type
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/he/multi-user-scheduler.h ns-3.45/src/wifi/model/he/multi-user-scheduler.h
--- ns-3.44/src/wifi/model/he/multi-user-scheduler.h	2025-03-09 16:55:49.791372500 -0700
+++ ns-3.45/src/wifi/model/he/multi-user-scheduler.h	2025-06-01 20:34:45.618702200 -0700
@@ -9,8 +9,6 @@
 #ifndef MULTI_USER_SCHEDULER_H
 #define MULTI_USER_SCHEDULER_H
 
-#include "he-ru.h"
-
 #include "ns3/ap-wifi-mac.h"
 #include "ns3/ctrl-headers.h"
 #include "ns3/object.h"
@@ -189,7 +187,9 @@
      */
     virtual void UpdateTriggerFrameAfterProtection(uint8_t linkId,
                                                    CtrlTriggerHeader& trigger,
-                                                   WifiTxParameters& txParams) const {};
+                                                   WifiTxParameters& txParams) const
+    {
+    }
 
     /**
      * Update the given PSDU map after protection is completed on the given link.
@@ -200,7 +200,9 @@
      */
     virtual void UpdateDlMuAfterProtection(uint8_t linkId,
                                            WifiPsduMap& psduMap,
-                                           WifiTxParameters& txParams) const {};
+                                           WifiTxParameters& txParams) const
+    {
+    }
 
     /**
      * Remove the User Info fields for which the given predicate is true from the given Trigger
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/he/rr-multi-user-scheduler.cc ns-3.45/src/wifi/model/he/rr-multi-user-scheduler.cc
--- ns-3.44/src/wifi/model/he/rr-multi-user-scheduler.cc	2025-03-09 16:55:49.791372500 -0700
+++ ns-3.45/src/wifi/model/he/rr-multi-user-scheduler.cc	2025-06-01 20:34:45.618702200 -0700
@@ -174,10 +174,32 @@
 {
     NS_LOG_FUNCTION(this);
 
+    auto heConfiguration = m_apMac->GetHeConfiguration();
+    NS_ASSERT(heConfiguration);
+
+    WifiTxVector txVector;
+    txVector.SetChannelWidth(m_allowedWidth);
+    txVector.SetGuardInterval(heConfiguration->GetGuardInterval());
+    txVector.SetBssColor(heConfiguration->m_bssColor);
+    txVector.SetPreambleType(WIFI_PREAMBLE_HE_TB);
+
+    const auto firstCandidate =
+        std::find_if(m_staListUl.begin(), m_staListUl.end(), canBeSolicited);
+    if (firstCandidate == m_staListUl.cend())
+    {
+        NS_LOG_DEBUG("No candidate");
+        return txVector;
+    }
+
     // determine RUs to allocate to stations
+    const auto isEht =
+        (m_apMac->GetEhtSupported() && m_apMac->GetEhtSupported(firstCandidate->address));
     auto count = std::min<std::size_t>(m_nStations, m_staListUl.size());
     std::size_t nCentral26TonesRus;
-    HeRu::GetEqualSizedRusForStations(m_allowedWidth, count, nCentral26TonesRus);
+    WifiRu::GetEqualSizedRusForStations(m_allowedWidth,
+                                        count,
+                                        nCentral26TonesRus,
+                                        isEht ? WIFI_MOD_CLASS_EHT : WIFI_MOD_CLASS_HE);
     NS_ASSERT(count >= 1);
 
     if (!m_useCentral26TonesRus)
@@ -185,17 +207,15 @@
         nCentral26TonesRus = 0;
     }
 
-    Ptr<HeConfiguration> heConfiguration = m_apMac->GetHeConfiguration();
-    NS_ASSERT(heConfiguration);
-
-    WifiTxVector txVector;
-    txVector.SetPreambleType(WIFI_PREAMBLE_HE_TB);
-    txVector.SetChannelWidth(m_allowedWidth);
-    txVector.SetGuardInterval(heConfiguration->GetGuardInterval());
-    txVector.SetBssColor(heConfiguration->m_bssColor);
+    if (isEht)
+    {
+        txVector.SetPreambleType(WIFI_PREAMBLE_EHT_TB);
+        txVector.SetEhtPpduType(0);
+    }
+    // TODO otherwise make sure the TX width does not exceed 160 MHz
 
     // iterate over the associated stations until an enough number of stations is identified
-    auto staIt = m_staListUl.begin();
+    auto staIt = firstCandidate;
     m_candidates.clear();
 
     while (staIt != m_staListUl.end() &&
@@ -204,51 +224,15 @@
     {
         NS_LOG_DEBUG("Next candidate STA (MAC=" << staIt->address << ", AID=" << staIt->aid << ")");
 
-        if (!canBeSolicited(*staIt))
-        {
-            NS_LOG_DEBUG("Skipping station based on provided function object");
-            staIt++;
-            continue;
-        }
-
         if (txVector.GetPreambleType() == WIFI_PREAMBLE_EHT_TB &&
             !m_apMac->GetEhtSupported(staIt->address))
         {
             NS_LOG_DEBUG(
                 "Skipping non-EHT STA because this Trigger Frame is only soliciting EHT STAs");
-            staIt++;
-            continue;
-        }
-
-        uint8_t tid = 0;
-        while (tid < 8)
-        {
-            // check that a BA agreement is established with the receiver for the
-            // considered TID, since ack sequences for UL MU require block ack
-            if (m_apMac->GetBaAgreementEstablishedAsRecipient(staIt->address, tid))
-            {
-                break;
-            }
-            ++tid;
-        }
-        if (tid == 8)
-        {
-            NS_LOG_DEBUG("No Block Ack agreement established with " << staIt->address);
-            staIt++;
+            staIt = std::find_if(++staIt, m_staListUl.end(), canBeSolicited);
             continue;
         }
 
-        // if the first candidate STA is an EHT STA, we switch to soliciting EHT TB PPDUs
-        if (txVector.GetHeMuUserInfoMap().empty())
-        {
-            if (m_apMac->GetEhtSupported() && m_apMac->GetEhtSupported(staIt->address))
-            {
-                txVector.SetPreambleType(WIFI_PREAMBLE_EHT_TB);
-                txVector.SetEhtPpduType(0);
-            }
-            // TODO otherwise, make sure the TX width does not exceed 160 MHz
-        }
-
         // prepare the MAC header of a frame that would be sent to the candidate station,
         // just for the purpose of retrieving the TXVECTOR used to transmit to that station
         WifiMacHeader hdr(WIFI_MAC_QOSDATA);
@@ -264,8 +248,8 @@
                                   suTxVector.GetNss()});
         m_candidates.emplace_back(staIt, nullptr);
 
-        // move to the next station in the list
-        staIt++;
+        // move to the next candidate station in the list
+        staIt = std::find_if(++staIt, m_staListUl.end(), canBeSolicited);
     }
 
     if (txVector.GetHeMuUserInfoMap().empty())
@@ -284,7 +268,26 @@
     // check if station has setup the current link
     if (!m_apMac->GetStaList(m_linkId).contains(info.aid))
     {
-        NS_LOG_INFO("STA with AID " << info.aid << " has not setup link " << +m_linkId);
+        NS_LOG_INFO("STA with AID " << info.aid << " has not setup link " << +m_linkId
+                                    << ": skipping station");
+        return false;
+    }
+
+    uint8_t tid = 0;
+    while (tid < 8)
+    {
+        // check that a BA agreement is established with the receiver for the
+        // considered TID, since ack sequences for UL MU require block ack
+        if (m_apMac->GetBaAgreementEstablishedAsRecipient(info.address, tid))
+        {
+            break;
+        }
+        ++tid;
+    }
+    if (tid == 8)
+    {
+        NS_LOG_DEBUG("No Block Ack agreement established with " << info.address
+                                                                << ": skipping station");
         return false;
     }
 
@@ -309,7 +312,8 @@
 
     if (!mapped)
     {
-        NS_LOG_DEBUG("MLD " << *mldAddr << " has not mapped any TID on link " << +m_linkId);
+        NS_LOG_DEBUG("MLD " << *mldAddr << " has not mapped any TID on link " << +m_linkId
+                            << ": skipping station");
         return false;
     }
 
@@ -324,7 +328,7 @@
                                      m_linkId,
                                      WifiQueueBlockedReason::WAITING_EMLSR_TRANSITION_DELAY)))
     {
-        NS_LOG_INFO("EMLSR client " << *mldAddr << " is using another link");
+        NS_LOG_INFO("EMLSR client " << *mldAddr << " is using another link: skipping station");
         return false;
     }
 
@@ -749,15 +753,7 @@
 
     std::size_t count =
         std::min(static_cast<std::size_t>(m_nStations), m_staListDl[primaryAc].size());
-    std::size_t nCentral26TonesRus;
-    HeRu::RuType ruType =
-        HeRu::GetEqualSizedRusForStations(m_allowedWidth, count, nCentral26TonesRus);
-    NS_ASSERT(count >= 1);
-
-    if (!m_useCentral26TonesRus)
-    {
-        nCentral26TonesRus = 0;
-    }
+    std::size_t nCentral26TonesRus{0};
 
     uint8_t currTid = wifiAcList.at(primaryAc).GetHighTid();
 
@@ -809,6 +805,7 @@
     ruAllocations.resize(numRuAllocs);
     NS_ASSERT((m_candidates.size() % numRuAllocs) == 0);
 
+    RuType ruType{RuType::RU_TYPE_MAX};
     while (staIt != m_staListDl[primaryAc].end() &&
            m_candidates.size() <
                std::min(static_cast<std::size_t>(m_nStations), count + nCentral26TonesRus))
@@ -823,8 +820,6 @@
             continue;
         }
 
-        HeRu::RuType currRuType = (m_candidates.size() < count ? ruType : HeRu::RU_26_TONE);
-
         // check if the AP has at least one frame to be sent to the current station
         for (uint8_t tid : tids)
         {
@@ -852,17 +847,37 @@
                     WifiTxVector txVectorCopy = m_txParams.m_txVector;
 
                     // the first candidate STA determines the preamble type for the DL MU PPDU
-                    if (m_candidates.empty() &&
-                        suTxVector.GetPreambleType() == WIFI_PREAMBLE_EHT_MU)
+                    if (m_candidates.empty())
                     {
-                        m_txParams.m_txVector.SetPreambleType(WIFI_PREAMBLE_EHT_MU);
-                        m_txParams.m_txVector.SetEhtPpduType(0); // indicates DL OFDMA transmission
+                        WifiModulationClass mc = WIFI_MOD_CLASS_HE;
+                        if (suTxVector.GetPreambleType() == WIFI_PREAMBLE_EHT_MU)
+                        {
+                            m_txParams.m_txVector.SetPreambleType(WIFI_PREAMBLE_EHT_MU);
+                            m_txParams.m_txVector.SetEhtPpduType(
+                                0); // indicates DL OFDMA transmission
+                            mc = WIFI_MOD_CLASS_EHT;
+                        }
+                        ruType = WifiRu::GetEqualSizedRusForStations(m_allowedWidth,
+                                                                     count,
+                                                                     nCentral26TonesRus,
+                                                                     mc);
+                        NS_ASSERT(count >= 1);
+                        if (!m_useCentral26TonesRus)
+                        {
+                            nCentral26TonesRus = 0;
+                        }
                     }
 
-                    m_txParams.m_txVector.SetHeMuUserInfo(staIt->aid,
-                                                          {{currRuType, 1, true},
-                                                           suTxVector.GetMode().GetMcsValue(),
-                                                           suTxVector.GetNss()});
+                    NS_ASSERT(ruType != RuType::RU_TYPE_MAX);
+                    const auto currRuType =
+                        (m_candidates.size() < count ? ruType : RuType::RU_26_TONE);
+                    const auto ru =
+                        (m_txParams.m_txVector.GetPreambleType() == WIFI_PREAMBLE_EHT_MU)
+                            ? WifiRu::RuSpec(EhtRu::RuSpec{currRuType, 1, true, true})
+                            : WifiRu::RuSpec(HeRu::RuSpec{currRuType, 1, true});
+                    m_txParams.m_txVector.SetHeMuUserInfo(
+                        staIt->aid,
+                        {ru, suTxVector.GetMode().GetMcsValue(), suTxVector.GetNss()});
 
                     if (!GetHeFem(m_linkId)->TryAddMpdu(mpdu, m_txParams, actualAvailableTime))
                     {
@@ -915,8 +930,10 @@
     // compute how many stations can be granted an RU and the RU size
     std::size_t nRusAssigned = m_candidates.size();
     std::size_t nCentral26TonesRus;
-    HeRu::RuType ruType =
-        HeRu::GetEqualSizedRusForStations(m_allowedWidth, nRusAssigned, nCentral26TonesRus);
+    const auto ruType = WifiRu::GetEqualSizedRusForStations(m_allowedWidth,
+                                                            nRusAssigned,
+                                                            nCentral26TonesRus,
+                                                            txVector.GetModulationClass());
 
     NS_LOG_DEBUG(nRusAssigned << " stations are being assigned a " << ruType << " RU");
 
@@ -934,10 +951,11 @@
     WifiTxVector::HeMuUserInfoMap heMuUserInfoMap;
     std::swap(heMuUserInfoMap, txVector.GetHeMuUserInfoMap());
 
+    const auto mc = IsEht(txVector.GetPreambleType()) ? WIFI_MOD_CLASS_EHT : WIFI_MOD_CLASS_HE;
     auto candidateIt = m_candidates.begin(); // iterator over the list of candidate receivers
-    auto ruSet = HeRu::GetRusOfType(m_allowedWidth, ruType);
+    auto ruSet = WifiRu::GetRusOfType(m_allowedWidth, ruType, mc);
     auto ruSetIt = ruSet.begin();
-    auto central26TonesRus = HeRu::GetCentral26TonesRus(m_allowedWidth, ruType);
+    auto central26TonesRus = WifiRu::GetCentral26TonesRus(m_allowedWidth, ruType, mc);
     auto central26TonesRusIt = central26TonesRus.begin();
 
     for (std::size_t i = 0; i < nRusAssigned + nCentral26TonesRus; i++)
@@ -965,10 +983,10 @@
     NS_LOG_FUNCTION(this << txDuration.As(Time::US) << txVector);
 
     // find how many RUs have been allocated for each RU type
-    std::map<HeRu::RuType, std::size_t> ruMap;
+    std::map<RuType, std::size_t> ruMap;
     for (const auto& userInfo : txVector.GetHeMuUserInfoMap())
     {
-        ruMap.insert({userInfo.second.ru.GetRuType(), 0}).first->second++;
+        ruMap.insert({WifiRu::GetRuType(userInfo.second.ru), 0}).first->second++;
     }
 
     // The amount of credits received by each station equals the TX duration (in
@@ -979,7 +997,7 @@
     double debitsPerMhz =
         txDuration.ToDouble(Time::US) /
         std::accumulate(ruMap.begin(), ruMap.end(), 0, [](uint16_t sum, auto pair) {
-            return sum + pair.second * HeRu::GetBandwidth(pair.first);
+            return sum + pair.second * WifiRu::GetBandwidth(pair.first);
         });
 
     // assign credits to all stations
@@ -995,7 +1013,8 @@
         auto mapIt = txVector.GetHeMuUserInfoMap().find(candidate.first->aid);
         NS_ASSERT(mapIt != txVector.GetHeMuUserInfoMap().end());
 
-        candidate.first->credits -= debitsPerMhz * HeRu::GetBandwidth(mapIt->second.ru.GetRuType());
+        candidate.first->credits -=
+            debitsPerMhz * WifiRu::GetBandwidth(WifiRu::GetRuType(mapIt->second.ru));
     }
 
     // sort the list in decreasing order of credits
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/ht/ht-capabilities.cc ns-3.45/src/wifi/model/ht/ht-capabilities.cc
--- ns-3.44/src/wifi/model/ht/ht-capabilities.cc	2025-03-09 16:55:49.791372500 -0700
+++ ns-3.45/src/wifi/model/ht/ht-capabilities.cc	2025-06-01 20:34:45.618702200 -0700
@@ -89,12 +89,18 @@
 void
 HtCapabilities::Print(std::ostream& os) const
 {
-    os << "HT Capabilities=" << bool(GetLdpc()) << "|" << bool(GetSupportedChannelWidth()) << "|"
-       << bool(GetShortGuardInterval20()) << "|";
+    os << "HT Capabilities=[LDPC: " << +m_ldpc
+       << ", Supported Channel Width: " << +m_supportedChannelWidth
+       << ", SGI 20MHz: " << +m_shortGuardInterval20 << ", SGI 40MHz: " << +m_shortGuardInterval40
+       << ", Supported MCS Set: {";
     for (uint8_t i = 0; i < MAX_SUPPORTED_MCS; i++)
     {
-        os << IsSupportedMcs(i) << " ";
+        if (IsSupportedMcs(i))
+        {
+            os << +i << " ";
+        }
     }
+    os << "}]";
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/ht/ht-capabilities.h ns-3.45/src/wifi/model/ht/ht-capabilities.h
--- ns-3.44/src/wifi/model/ht/ht-capabilities.h	2025-03-09 16:55:49.791372500 -0700
+++ ns-3.45/src/wifi/model/ht/ht-capabilities.h	2025-06-01 20:34:45.618702200 -0700
@@ -25,7 +25,7 @@
  * @brief The HT Capabilities Information Element
  * @ingroup wifi
  *
- * This class knows how to serialise and deserialise the HT Capabilities Information Element
+ * This class knows how to serialize and deserialize the HT Capabilities Information Element
  */
 class HtCapabilities : public WifiInformationElement
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/ht/ht-configuration.cc ns-3.45/src/wifi/model/ht/ht-configuration.cc
--- ns-3.44/src/wifi/model/ht/ht-configuration.cc	2025-03-09 16:55:49.791372500 -0700
+++ ns-3.45/src/wifi/model/ht/ht-configuration.cc	2025-06-01 20:34:45.618702200 -0700
@@ -47,11 +47,15 @@
                           BooleanValue(false),
                           MakeBooleanAccessor(&HtConfiguration::m_ldpcSupported),
                           MakeBooleanChecker())
+            // NS_DEPRECATED_3_45
             .AddAttribute("Support40MHzOperation",
                           "Whether or not 40 MHz operation is to be supported.",
                           BooleanValue(true),
                           MakeBooleanAccessor(&HtConfiguration::m_40MHzSupported),
-                          MakeBooleanChecker());
+                          MakeBooleanChecker(),
+                          TypeId::SupportLevel::OBSOLETE,
+                          "Set an initial channel via WifiPhy::ChannelSettings whose width "
+                          "corresponds to the maximum desired width instead");
     return tid;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/ht/ht-configuration.h ns-3.45/src/wifi/model/ht/ht-configuration.h
--- ns-3.44/src/wifi/model/ht/ht-configuration.h	2025-03-09 16:55:49.791372500 -0700
+++ ns-3.45/src/wifi/model/ht/ht-configuration.h	2025-06-01 20:34:45.618702200 -0700
@@ -77,14 +77,14 @@
      * @param enable true if both 20 MHz and 40 MHz operation is to be supported,
      *               false if only 20 MHz operation is to be supported
      */
-    NS_DEPRECATED_3_44("Set the m_40MHzSupported member variable instead")
+    NS_DEPRECATED_3_44("Set the ChannelSettings of the WifiPhy instead")
     void Set40MHzOperationSupported(bool enable);
 
     /**
      * @return true if both 20 MHz and 40 MHz operation is supported, false if
      *         only 20 MHz operation is supported
      */
-    NS_DEPRECATED_3_44("Get the m_40MHzSupported member variable instead")
+    NS_DEPRECATED_3_45("Use WifiPhy::GetChannelWidth instead")
     bool Get40MHzOperationSupported() const;
 
     bool m_sgiSupported;   ///< flag whether short guard interval is supported
